<template>
    <v-layout column pb-2 v-if="this.xisauto === 'Y'">
        <v-card class="mb-2" color="white">
            <v-layout row wrap>
                <v-flex class="border-bottom-dashed" xs12 pt-2 pl-4 pr-4 pb-4>
                    <table>
                        <tr>
                            <th class="text-md-center pt-2 pb-2">NO. PEMBAYARAN</th>
                            <th class="text-md-center pt-2 pb-2"> TIPE PEMBAYARAN </th>
                            <th class="text-md-center pt-2 pb-2">JUMLAH</th>
                            <th class="text-md-center pt-2 pb-2">USER</th>
                            <th class="text-md-center pt-2 pb-2">AKSI</th>
                        </tr>
                        <tr class="mini-input" v-if="notes.length > 0" v-for="(note,index) in notes">
                            <td width="30%" v-bind:class="{ 'red--text':note.note_active === 'N','primary--text':note.note_amount < 0}" style="text-align:center;vertical-align:center;"
                                align="center">{{note.note_number}}</td>
                            <td width="30%" v-bind:class="{ 'red--text':note.note_active === 'N','primary--text':note.note_amount < 0}" class="text-md-center pl-3 pr-3">{{note.paymenttypes_name}}</td>
                            <td width="15%" v-bind:class="{ 'red--text':note.note_active === 'N','primary--text':note.note_amount < 0}" class="text-md-right pl-3 pr-3">{{convertMoney(note.note_amount)}}</td>
                            <td width="20%" v-bind:class="{ 'red--text':note.note_active === 'N','primary--text':note.note_amount < 0}" class="text-md-center pr-2">{{note.note_user}}</td>
                            <td class="text-md-center">
                                <span @click="printNote(note,index)" class="icon-medium-fill-base xs1 white--text grey darken-1 icon-print"></span>
                                <!--<v-btn small  @click="printNote(note,index)" color="primary" dark>
                                    Print
                                </v-btn>

                                <v-btn small  @click="deleteNote(note,index)" v-if="note.note_active === 'Y'" color="error" dark>
                                    Hapus
                                </v-btn>-->

                            </td>
                        </tr>
                        <tr class="mini-input" v-if="notes.length ===  0">
                            <td colspan="5" class="text-md-center pr-2">
                                Tidak ada data
                            </td>
                        </tr>
                    </table>
            </v-layout>
            <v-layout style="border-top:1px dashed rgb(221,221,221)" row mt-1 mb-1></v-layout>
            <v-layout row mt-1 mb-1 pl-2 pr-2>
            </v-layout>
            </v-flex>
        </v-card>
        <v-card>
            <v-layout row pa-2 align-center wrap>
                <v-flex xs6>
                    <v-layout row>
                        <v-flex xs12>
                            <div class="label-tagihan text-xs-left">Total Tagihan</div>
                        </v-flex>
                    </v-layout>
                    <v-layout pt-1 row>
                        <v-flex xs9>
                            <!--<div class="text-xs-left warning--text">Minimun DP ({{xmindp_percent}}%)</div>-->
                        </v-flex>
                        <v-flex xs3>
                            <!--<div class="text-xs-right warning--text">{{convertMoney(xmindp_amount)}}</div>-->
                        </v-flex>
                    </v-layout>
                </v-flex>
                <v-flex xs6>
                    <div class="text-tagihan text-xs-right"><kbd>{{convertMoney(restbill)}}</kbd></div>
                </v-flex>
            </v-layout>
            <v-layout style="border-top:1px dashed rgb(221,221,221)" row mt-1 mb-1></v-layout>
            <div v-for="(type, index) in types">
                <v-layout row pt-2 pb-1 pl-2 align-center wrap>
                    <v-flex xs12>
                        <v-switch v-model="type.chex" @change="updateChx(type,index)" :label="type.chexlabel"></v-switch>
                    </v-flex>
                </v-layout>
                <v-layout pl-2 row align-center wrap>
                    <v-flex xs4 class="pa-1">
                        <!--<input type="text" @change="updateTotal()" :class="{ 'disabled-background':type.chex === false }" :disabled="!type.chex"  v-model="type.leftvalue" class="input-plain text-xs-right font-weight-bold"/>-->
                        <v-text-field label="Jumlah" :disabled="!type.chex" v-model="type.leftvalue" @change="updateTotal()" class="amount-right"
                            reverse outline></v-text-field>
                    </v-flex>
                    <v-flex xs4 v-if="type.code === 'CASH' || type.code === 'VOUCHER'" class="pa-1">
                        <v-text-field v-if="type.code === 'CASH'" label="Kembali" :disabled="!type.chex" v-model="type.rightvalue" class="amount-right"
                            reverse @change="updateTotal()" outline></v-text-field>
                        <v-text-field v-if="type.code === 'VOUCHER'" label="Kode Voucher" :disabled="!type.chex" v-model="type.rightvalue" class="amount-right"
                            outline></v-text-field>
                    </v-flex>
                    <v-flex xs4 v-if="type.code === 'DEBIT' || type.code === 'CREDIT' || type.code === 'TRANSFER'" class="pa-1">
                        <v-autocomplete v-if="type.code !== 'TRANSFER'" label="Kartu" v-model="type.selected_card" @change="changeCard('card',type.selected_card,index)"
                            :disabled="!type.chex" :items="banks" auto-select-first no-filter outline item-text="name" item-value="id"
                            return-object no-data-text="">
                        </v-autocomplete>
                        <v-autocomplete v-if="type.code === 'TRANSFER'" label="Nomor Rekening" v-model="type.selected_account" @change="changeCard('account',type.selected_account,index)"
                            :disabled="!type.chex" :items="accounts" auto-select-first outline no-filter item-text="name" item-value="id"
                            return-object no-data-text="">
                        </v-autocomplete>
                    </v-flex>
                    <v-flex xs4 v-if="type.code === 'DEBIT' || type.code === 'CREDIT'" class="pa-1">
                        <v-autocomplete label="EDC" v-model="type.selected_edc" @change="changeCard('edc',type.selected_card,index)" :disabled="!type.chex"
                            :items="accounts" auto-select-first outline no-filter item-text="name" item-value="id" return-object
                            no-data-text="">
                        </v-autocomplete>
                    </v-flex>
                </v-layout>
                <v-layout style="border-top:1px dashed rgb(221,221,221)" row mt-1 mb-1></v-layout>
            </div>
            <v-layout row pa-2 align-center wrap>
                <v-flex xs6>
                    <div class="label-tagihan text-xs-left">
                        <v-btn v-if="xdisable_btn_pay === 'N'" :disabled="in_saving" @click="pay()" color="warning" dark>
                            Bayar
                        </v-btn>
                    </div>
                </v-flex>
                <v-flex xs6>
                    <div class="text-tagihan text-xs-right"><kbd>{{convertMoney(totpay)}}</kbd></div>
                </v-flex>
            </v-layout>
        </v-card>



        <template>
            <v-dialog v-model="xdialogpaysuccess" max-width="30%" persistent>
                <v-card>
                    <v-card-title class="headline success pt-2 pb-2" primary-title>
                        <h4 style="color:#FFEBEE">Pembayaran Berhasil</h4>
                    </v-card-title>
                    <v-card-text class="pt-2 pb-2">
                        <v-layout row>
                            <v-flex xs12 d-flex>
                                <v-layout row>
                                    <v-flex pb-1 xs12>
                                        <v-layout row>
                                            <v-flex pt-2 pr-2 v-html="xmsgpaysuccess" xs12>

                                            </v-flex>
                                        </v-layout>
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                        </v-layout>
                    </v-card-text>
                    <v-divider></v-divider>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn flat @click="doPrint()">
                            Print
                        </v-btn>
                        <v-btn color="error" flat @click="closeDialogPaySuccess(false)">
                            Tutup
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </template>

        <template>

            <v-dialog v-model="xdialogdelete" persistent max-width="30%">
                <v-card>
                    <v-card-title :class="{ 'red':!_.isEmpty(xnotadelete), 'success':_.isEmpty(xnotadelete) }" class="headline darken-1 pt-2 pb-2"
                        primary-title>
                        <h4 style="color:#FFEBEE">
                            <span v-if="!_.isEmpty(xnotadelete)">Peringatan !</span>
                            <span v-if="_.isEmpty(xnotadelete)">Berhasil !</span>
                        </h4>
                    </v-card-title>
                    <v-card-text class="pt-2 pb-2">
                        <v-layout row>
                            <v-flex xs12 d-flex>
                                <v-layout row>
                                    <v-flex pb-1 xs12>
                                        <v-layout row>
                                            <v-flex pt-2 pr-2 v-html="xmsgdelete" xs12>

                                            </v-flex>
                                        </v-layout>
                                        <v-layout v-if="!_.isEmpty(xnotadelete)" row>
                                            <v-flex pt-2 pr-2 xs12>
                                                <input style="border: 1px solid black;padding: 5px;width: 100%;" type="text" placeholder="Catatan (*Wajib diisi)" v-model="xnotedelete"
                                                    class="input-plain" />
                                            </v-flex>
                                        </v-layout>
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                        </v-layout>
                    </v-card-text>
                    <v-divider></v-divider>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="error" v-if="!_.isEmpty(xnotadelete) && xnotedelete " flat @click="doDeleteNote()">
                            Yakin dong !
                        </v-btn>

                        <v-btn v-if="!_.isEmpty(xnotadelete)" color="primary" flat @click="xdialogdelete = false">
                            Tutup
                        </v-btn>
                        <v-btn v-if="_.isEmpty(xnotadelete)" color="primary" flat @click="closeDialogDelete()">
                            Tutup
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

        </template>
        <one-dialog-print :title="printtitle" :width="printwidth" :height="550" :status="openprintnote" :urlprint="urlprintnote"
            @close-dialog-print="openprintnote = false"></one-dialog-print>
            <one-dialog-info :status="opendialoginfo" :msg="msginfo" @close-dialog-info="opendialoginfo = false"></one-dialog-info>
    </v-layout>
</template>
<style scoped>
    .rTable {
        display: table;
        width: 100%;
        border-spacing: 0 .2em;
    }

    .rTableGroup {
        display: table-row-group;
    }

    .rTableRow {
        display: table-row;
        font-size: 14px;
        -webkit-flex-wrap: wrap;
        /* Safari 6.1+ */
        flex-wrap: wrap;

    }

    .rTableHeading {
        display: table-header-group;
        background-color: #fffff;
    }

    .rTableCell {
        display: table-cell;
        padding-left: 10px;
        padding-right: 10px;
        padding-top: 5px;
        padding-bottom: 5px;
        line-height: 2;
        border: 1px solid #2196f3;
        background-color: #fffff;
        border-spacing: 5px;
    }

    .rTableHead {
        display: table-cell;
        padding-left: 10px;
        padding-right: 10px;
        padding-top: 10px;
        padding-bottom: 0px;
        background-color: #fffff;
    }

    .rTableHeading {
        display: table-header-group;
        text-transform: uppercase;
        font-weight: 500;
    }

    .rTableFoot {
        display: table-footer-group;
        font-weight: bold;
        background-color: #ddd;
    }

    .rTableBody {
        display: table-row-group;
    }

    .rfirstCell {
        border-left: 10px solid #2196f3;
        border-top-left-radius: 3px;
        border-bottom-left-radius: 3px;
    }

    .caption {
        border: 1px solid grey;
        caption-side: bottom;
        display: table-caption;
        text-align: center;
        padding: 5px
    }

    .label-tagihan {
        text-align: left;
        font-size: 25px;
        font-family: open sans, tahoma, sans-serif;
        font-weight: 700;
    }

    .sub-header {
        text-align: left;
        font-size: 18px;
        font-family: open sans, tahoma, sans-serif;
        font-weight: 700;
    }

    .sub-title {
        text-align: left;
        font-size: 14px;
        font-family: open sans, tahoma, sans-serif;
        font-weight: 700;
    }

    .amount-right {
        text-align: right !important;
        font-size: 14px;
        font-family: open sans, tahoma, sans-serif;
        font-weight: 700;
    }

    .text-tagihan {
        text-align: left;
        font-size: 42px;
        font-family: open sans, tahoma, sans-serif;
    }

    .disabled-background {
        background: #b7b7b7;
    }

    .input-cash {
        width: 100%;
        padding: 8px 14px;
        box-sizing: border-box;
        border: 2px solid grey;
        border-radius: 4px;
        font-size: 22px;
        font-weight: 700;
        text-align: right;
    }

    .input-plain {
        width: 100%;
        padding: 4px 8px;
        box-sizing: border-box;
        border: 2px solid grey;
        border-radius: 4px;
        font-size: 14px;
    }

    .v-input,
    .v-input__slot,
    .v-messages {
        margin: 0px;
        padding: 0px;
        min-height: 0px;
    }

    .v-input--selection-controls:not(.v-input--hide-details) .v-input__slot {
        margin-bottom: 0px;
    }

    table {
        font-family: arial, sans-serif;
        border-collapse: collapse;
        width: 100%;
        background: white;
        border: 0px;
    }

    th,
    td {
        border: 1px solid black;
        border-collapse: collapse;
        padding-top: 2px;
        padding-bottom: 2px;
    }

    table>tr>td {
        padding: 8px;
    }

    table>tr>td:first {
        padding-left: 15px !important;
    }

    .mini-input .v-input {
        margin-top: 0px;
    }

    .mini-input .v-input,
    .mini-input .v-input--selection-controls,
    .mini-input .v-input__slot {
        margin-top: 0px;
        margin-bottom: 0px;
        margin-left: 3px;
    }

    .mini-input .v-messages {
        min-height: 0px;
    }

    .border-bottom-dashed {
        border-bottom: 1px dashed rgba(0, 0, 0, .12);
    }
</style>
<script>
    module.exports = {
        components: {
            'one-dialog-info': httpVueLoader('../../common/oneDialogInfo.vue'),
            'one-field-verification': httpVueLoader('../../common/oneFieldVerificationSupply.vue'),
            'one-dialog-print': httpVueLoader('../../common/oneDialogPrintX.vue')
        },
        data() {
            return {
                checkbox: true,
                radioGroup: 1,
                switchCash: true,
                switchDebit: false,
                switchKredit: false,
                dialog: false,
                urlprintnote: '',
                printtitle: '',
                printwidth: '60%',
                search_card: '',
                search_edc: '',
                isLoading: false,
                fajrihidebtnpay: 'Y'
            }
        },
        mounted() {
            this.$store.dispatch("paymentnew/lookup_type")
            this.$store.dispatch("paymentnew/lookup_banks")
            this.$store.dispatch("paymentnew/lookup_accounts")
        },
        computed: {
            opendialoginfo: {
            get() {
                return this.$store.state.paymentnew.open_dialog_info
            },
            set(val) {
                this.$store.commit("paymentnew/update_open_dialog_info",false)
            }
        },
        msginfo: {
            get() {
                return this.$store.state.paymentnew.msg_info
            },
            set(val) {
                this.$store.commit("paymentnew/update_msg_info",false)
            }
        },
            cards() {
                return this.$store.state.paymentnew.cards
            },
            banks() {
                return this.$store.state.paymentnew.banks
            },
            accounts() {
                return this.$store.state.paymentnew.accounts
            },
            xmindp_percent() {
                if (this.$store.state.bill.selected_bill) {
                    return this.$store.state.bill.selected_bill.mindp_percent
                } else {
                    return 0
                }
            },
            xmindp_amount() {
                if (this.$store.state.bill.selected_bill) {
                    return this.$store.state.bill.selected_bill.mindp_amount
                } else {
                    return 0
                }
            },
            notes() {
                return this.$store.state.paymentnew.notes

            },
            xordertests() {
                return this.$store.state.paymentnew.ordertests
            },
            xdialogpaysuccess() {
                return this.$store.state.paymentnew.dialog_pay_success
            },
            xmsgpaysuccess() {
                return this.$store.state.paymentnew.paynumber
            },
            types() {
                return this.$store.state.paymentnew.types
            },
            totpay() {
                return this.$store.state.paymentnew.total_payment
            },
            restbill() {
                if (this.$store.state.bill.bills) {
                    return this.$store.state.bill.selected_bill.unpaid
                } else {
                    return 0
                }

            },
            xdialogdelete: {
                get() {
                    return this.$store.state.paymentnew.dialog_delete
                },
                set(val) {
                    this.$store.commit("paymentnew/update_dialog_delete", val)
                }
            },
            xmsgdelete() {
                return this.$store.state.paymentnew.msg_delete
            },
            xnotadelete() {
                return this.$store.state.paymentnew.nota_delete
            },
            xnotedelete: {
                get() {
                    return this.$store.state.paymentnew.note_delete
                },
                set(val) {
                    this.$store.commit("paymentnew/update_note_delete", val)
                }
            },
            openprintnote: {
                get() {
                    return this.$store.state.paymentnew.open_print_note
                },
                set(val) {
                    this.$store.commit("paymentnew/update_open_print_note", false)
                }
            },
            selectedbill() {
                return this.$store.state.bill.selected_bill
            },
            xdisable_btn_pay: {
                get() {
                    return this.$store.state.paymentnew.disable_btn_pay
                },
                set(val) {
                    this.$store.commit("paymentnew/update_disable_btn_pay", val)
                }
            },
            xisauto: {
                get() {
                    return this.$store.state.paymentnew.isauto
                },
                set(val) {
                    this.$store.commit("paymentnew/update_isauto", val)
                }
            },
            in_saving: {
                get() {
                    return this.$store.state.paymentnew.in_saving
                },
                set(val) {
                    this.$store.commit("paymentnew/update_in_saving", val)
                }
            }
        },
        methods: {
            changeCard(type, value, idx) {
                var types = this.$store.state.paymentnew.types
                if (type === 'card')
                    types[idx].selected_card = value

                if (type === 'edc')
                    types[idx].selected_edc = value

                if (type === 'account')
                    types[idx].selected_account = value

                this.updateTotal()
            },
            colorbginp(value) {
                if (value.chex === false) {
                    return 'grey'
                } else {
                    return 'white'
                }
            },
            showDetail(idx) {
                var arrOrders = this.$store.state.paymentnew.notes
                arrOrders[idx].show_detail = arrOrders[idx].show_detail === 'Y' ? 'N' : 'Y'
                this.$store.commit("paymentnew/update_ordertests", arrOrders)
            },
            hideDetail(idx) {
                var arrOrders = this.$store.state.paymentnew.notes

                arrOrders[idx].show_detail = arrOrders[idx].show_detail === 'Y' ? 'N' : 'Y'
                this.$store.commit("paymentnew/update_ordertests", arrOrders)
            },
            convertMoney(money) {
                return one_money(money)
            },
            closeDialogPaySuccess() {
                let arrbill = this.$store.state.bill.bills
                var idx = _.findIndex(arrbill, item => item.F_BillID === this.$store.state.bill.selected_bill
                    .F_BillID)
                this.$store.commit("paymentnew/update_dialog_pay_success", false)
                this.$store.commit("bill/update_selected_bill", {})
                console.log(this.$store.state.paymentnew.types)
                this.$store.dispatch("bill/search", {
                    startdate: this.$store.state.bill.start_date,
                    enddate: this.$store.state.bill.end_date,
                    search: this.$store.state.bill.search,
                    status: this.$store.state.bill.selected_status.value,
                    current_page: this.$store.state.bill.current_page,
                    lastidx: idx
                })
            },
            updateTotal() {
                var xval = this.$store.state.paymentnew.types
                let xcash = _.filter(xval, {
                    code: 'CASH'
                })
                let xother = _.filter(xval, type => type.code !== 'CASH')
                var valother = 0
                xother.forEach(function (obj) {
                    valother += parseInt(obj.leftvalue)
                })
                //console.log('val other '+valother)
                let restother = this.restbill - valother

                let xchange = parseInt(xcash[0].leftvalue) - restother
                xcash[0].rightvalue = Math.max(0, xchange)
                let idxcash = _.findIndex(xval, item => item.code === 'CASH')
                xval[idxcash] = xcash[0]
                this.$store.commit("paymentnew/update_types", {
                    records: xval,
                    total: xval.length
                })
                let totpaid = valother + (parseInt(xcash[0].leftvalue) - Math.max(0, xchange))
                this.$store.commit("paymentnew/update_total_payment", totpaid)

                this.xdisable_btn_pay = 'Y'
                var payments = this.$store.state.paymentnew.types
                let selected_payments = _.filter(payments, {
                    chex: true
                })
                //console.log(this.xdisable_btn_pay)
                var xxx = 'Y'
                selected_payments.forEach(function (obj) {
                    if (parseInt(obj.leftvalue) !== 0)
                        xxx = 'N'

                    if ((obj.code === 'DEBIT' && parseInt(obj.selected_card.id) !== 0) || (obj.code ===
                            'DEBIT' && parseInt(obj.selected_edc.id) !== 0))
                        xxx = 'N'

                    if ((obj.code === 'CREDIT' && parseInt(obj.selected_card.id) !== 0) || (obj.code ===
                            'CREDIT' && parseInt(obj.selected_edc.id) !== 0))
                        xxx = 'N'

                })
                this.xdisable_btn_pay = xxx
                //console.log('after '+this.xdisable_btn_pay)
            },
            async pay() {
                if (this.in_saving) return;
                this.in_saving = true;
            var go_pay = true
            let xval = this.$store.state.paymentnew.types
            var valpay = 0
            var xmsginfo = ''
            let xcash = _.filter(xval, {code: 'CASH'})
            xval.forEach(function(obj){
                valpay += parseInt(obj.leftvalue)
            })
            let selected_payments = _.filter(this.$store.state.paymentnew.types, {chex: true})
            //console.log(selected_payments)
            selected_payments.forEach(function(xobj){
                var obj = JSON.parse(JSON.stringify(xobj))
                console.log(obj)
                console.log(parseInt(obj.selected_account.id))
                    if(obj.code === 'CASH' && parseInt(obj.leftvalue) === 0){
                        go_pay = false
                        xmsginfo += "<p>Mau bayar pake daun ?</p>"
                        this.xdisable_btn_pay = 'N'
                        this.in_saving = false
                    }   
                    else if(obj.code === 'DEBIT' && ( parseInt(obj.leftvalue) === 0 || parseInt(obj.selected_card.id) === 0 ||  parseInt(obj.selected_edc.id) === 0 )){
                        console.log(obj.code)
                        go_pay = false
                        xmsginfo += "<p>Bawain pacar bibit buah kedongdong, Kalo bayar pake debit diisi yang lengkap dong</p>"
                        this.xdisable_btn_pay = 'N'
                        this.in_saving = false
                    }   
                    else if(obj.code === 'CREDIT' && ( parseInt(obj.leftvalue) === 0 || parseInt(obj.selected_card.id) === 0 ||  parseInt(obj.selected_edc.id) === 0 )){
                        go_pay = false
                        xmsginfo += "<p>Pergi berlayar pake odong-odong, Kalo bayar pake kredit diisi yang lengkap dong</p>"
                        this.xdisable_btn_pay = 'N'
                        this.in_saving = false
                    }
                    else if(obj.code === 'TRANSFER' && ( parseInt(obj.leftvalue) === 0 || parseInt(obj.selected_account.id) === 0  || obj.selected_account === '')){
                        go_pay = false
                        xmsginfo += "<p>Salah bermanuver kecebur selokan dong, Kalo mau transfer diisi yang lengkap dong</p>"
                        this.xdisable_btn_pay = 'N'
                        this.in_saving = false
                    }

                    

            })
            if(selected_payments.length > 0 && go_pay){
                 let prm = {
                    orderid: this.$store.state.bill.selected_bill.F_BillID,
                    payments: this.$store.state.paymentnew.types
                }
                this.$store.dispatch("paymentnew/pay", prm)
            }
            else{
                if(selected_payments.length == 0)
                    xmsginfo += "<p>Mau bayar pake daun ?</p>"

                this.$store.commit("paymentnew/update_msg_info",xmsginfo)
                this.$store.commit("paymentnew/update_open_dialog_info",true)
                this.xdisable_btn_pay = 'N'
                        this.in_saving = false
               // console.log(this.opendialoginfo)
            }
            },
            deleteNote(note, idx) {
                this.$store.commit("paymentnew/update_note_delete", "")
                this.$store.commit("paymentnew/update_nota_delete", note)
                let xmsg = "Yakin , mau hapus nota nomor <span style='color:red'>" + note.note_number + "</span> ?"
                this.$store.commit("paymentnew/update_msg_delete", xmsg)
                this.$store.commit("paymentnew/update_dialog_delete", true)
            },
            doDeleteNote() {
                let prm = {
                    catatan: this.$store.state.paymentnew.note_delete,
                    nota: this.$store.state.paymentnew.nota_delete
                }
                this.$store.dispatch("paymentnew/delete_note", prm)
            },
            closeDialogDelete() {
                let arrbill = this.$store.state.bill.bills
                var idx = _.findIndex(arrbill, item => item.F_BillID === this.$store.state.bill.selected_bill
                    .F_BillID)
                this.$store.commit("paymentnew/update_dialog_delete", false)
                this.$store.commit("bill/update_selected_bill", {})
                this.$store.dispatch("bill/search", {
                    startdate: this.$store.state.bill.start_date,
                    enddate: this.$store.state.bill.end_date,
                    search: this.$store.state.bill.search,
                    status: this.$store.state.bill.selected_status.value,
                    lastidx: idx
                })
            },
            updateChx(val, idx) {
                var selpat = this.$store.state.bill.selected_bill
                var firstamount = 0
                if (selpat.unpaid)
                    firstamount = selpat.unpaid
                let xobj = this.$store.state.paymentnew.types

                if ((xobj[idx].code === 'DEBIT' || xobj[idx].code === 'CREDIT' || xobj[idx].code === 'TRANSFER') &&
                    val.chex === false) {
                    xobj[idx].selected_card = {
                        id: 0,
                        name: ''
                    }
                    xobj[idx].selected_edc = {
                        id: 0,
                        name: ''
                    }
                    xobj[idx].selected_account = {
                        id: 0,
                        name: ''
                    }
                }

                var valother = 0
                xobj.forEach(function (obj) {
                    if (obj.chex && (obj.code != val.code))
                        valother += parseInt(obj.leftvalue)
                })

                if (!val.chex) {
                    xobj[idx].leftvalue = 0
                    var x = "Y"
                    this.xdisable_btn_pay = x
                    console.log('disable ' + this.xdisable_btn_pay)
                } else
                    xobj[idx].leftvalue = firstamount - valother

                this.$store.commit("paymentnew/update_types", {
                    records: xobj,
                    total: xobj.length
                })
                this.updateTotal()
            },
            check_disable_btn_status() {
                this.xdisable_btn_pay = 'N'
                var payments = this.$store.state.paymentnew.types
                let selected_payments = _.filter(payments, {
                    chex: true
                })
                console.log(this.xdisable_btn_pay)
                selected_payments.forEach(function (obj) {
                    if (obj.leftvalue === 0) {
                        this.xdisable_btn_pay = 'Y'
                    }
                    if (obj.code === 'DEBIT' || obj.code === 'CREDIT' || obj.code === 'TRANSFER') {
                        console.log(obj)
                        if (obj.selected_card.id === '0' || obj.selected_card.id === 0 || obj.selected_edc.id ===
                            '0' || obj.selected_edc.id === 0 || obj.selected_account.id === '0' || obj.selected_account
                            .id === 0) {
                            this.xdisable_btn_pay = 'Y'
                            console.log('oye')
                            console.log(this.xdisable_btn_pay)
                        }
                    }
                })
            },
            printNote(val, idx) {
                this.printwidth = 600
                this.printtitle = ""
                let user = one_user()
                var rpt = 'rpt_t_010'
                if (val.note_amount < 0)
                    rpt = 'rpt_t_010'
                this.urlprintnote = "/birt/run?__report=report/one/fo/" + rpt + ".rptdesign&__format=pdf&username=" +
                    user.M_UserUsername + "&PID=" + val.note_id
                this.$store.commit("paymentnew/update_open_print_note", true)
            },
            doPrint() {
                this.printtitle = ""
                this.closeDialogPaySuccess()
                let user = one_user()
                let payments = this.$store.state.paymentnew.last_payments
                let xcash = _.filter(payments, {
                    code: 'CASH'
                })
                var rpt = 'rpt_t_010'
                if (xcash[0].leftvalue < 0)
                    rpt = 'rpt_t_010'
                this.urlprintnote = "/birt/run?__report=report/one/fo/" + rpt + ".rptdesign&__format=pdf&username=" +
                    user.M_UserUsername + "&PID=" + this.$store.state.paymentnew.idx
                this.$store.commit("paymentnew/update_open_print_note", true)
            },
            printKw() {
                this.printwidth = 800
                this.printtitle = ""
                let idx = this.$store.state.bill.selected_bill.F_BillID
                let user = one_user()
                this.urlprintnote = "/birt/run?__report=report/one/fo/rpt_t_002.rptdesign&__format=pdf&username=" +
                    user.M_UserUsername + "&PID=" + idx
                this.$store.commit("paymentnew/update_open_print_note", true)
            },
            printInvoice() {
                this.printwidth = 800
                this.printtitle = ""
                let idx = this.$store.state.bill.selected_bill.F_BillID
                let user = one_user()
                this.urlprintnote = "/birt/run?__report=report/one/fo/rpt_t_001.rptdesign&__format=pdf&username=" +
                    user.M_UserUsername + "&PID=" + idx
                this.$store.commit("paymentnew/update_open_print_note", true)
            }
        }
    }
</script>